
// Example: locality of memory references
// Use gcc -std=c99
// Run program with/without argument, e.g.:
//  1)  time ./prog arg
//  2)  time ./prog

#include <stdio.h>
#include <time.h>

#define N 20000         // value depends on available memory
int p[N][N];

int main(int argc, char *argv[])
{
    printf("%dx%d int array:\n", N, N);
    {
        clock_t start = clock();
        for (int j = 0; j < N; ++j)
            for (int i = 0; i < N; ++i)
                p[i][j] += i + j;
        clock_t end = clock();
        printf("%.3gs\t",(end-start)/(double)CLOCKS_PER_SEC);
        printf("using column-major access\n");
    }
    {
        clock_t start = clock();
        for (int i = 0; i < N; ++i)
            for (int j = 0; j < N; ++j)
                p[i][j] += i + j;
        clock_t end = clock();
        printf("%.3gs\t",(end-start)/(double)CLOCKS_PER_SEC);
        printf("using row-major access\n");
    }
    return p[10][10];
}

