#!/bin/bash

F=ijc-test-standard-gen.c
cat >$F <<__END__
/* print values of standard macros __STDC__, __STDC_VERSION__ */

#include <stdio.h>      /* printf() */

int main() {
    printf("__STDC__ = %d\n", __STDC__);
#if defined(__STDC_VERSION__)
    printf("__STDC_VERSION__ = %ld\n", __STDC_VERSION__);
#endif
    return 0;
}
__END__

echo "Standard macros (default for gcc) "
gcc $F && ./a.out
echo
rm ./a.out

for v in c90 c99 c11 c18 ; do
    echo "Standard macros defined for  gcc -std=$v "
    gcc -std=$v $F && ./a.out
    echo
    rm ./a.out
done
rm $F
